package com.base.filerecoveryrecyclebin.ads

import android.app.Activity
import android.util.Log
import android.view.ViewGroup
import com.base.filerecoveryrecyclebin.R
import com.base.filerecoveryrecyclebin.ads.admob.AdmobInterstitialUtils
import com.base.filerecoveryrecyclebin.ads.admob.AdmobNativeUtils
import com.base.filerecoveryrecyclebin.ads.admob.AdmobOpenUtils
import com.base.filerecoveryrecyclebin.help.BaseApplication
import com.base.filerecoveryrecyclebin.utils.AppPreferences
import com.base.filerecoveryrecyclebin.utils.EventUtils
import com.base.filerecoveryrecyclebin.utils.LogEx
import com.google.android.gms.ads.MobileAds
import java.util.concurrent.atomic.AtomicBoolean

object AdmobMaxHelper {
    private val TAG = "AdmobMaxHelper"
    var isAdInit = AtomicBoolean(false)
    var isBlack: Boolean = false

    fun haveSpAdmobTrueMaxFalse(): Boolean {
        return AppPreferences.getInstance().getString("admobTrueMaxFalse", "-1").toInt() != -1
    }

    private fun getSpAdmobTrueMaxFalse(): Boolean {
        val ss = AppPreferences.getInstance().getString("admobTrueMaxFalse", "1").toInt()
        return ss == 1
    }

    fun showBackInterAdSp(): Boolean {
        val isShowBackIntAd = AppPreferences.getInstance().getString("isShowBackIntAd", "0").toInt()
        //1要看插屏 0不看
        return isShowBackIntAd == 1
    }

    fun showDeleteAdSp(): Boolean {
        val isDeleteInterAd = AppPreferences.getInstance().getString("isDeleteInterAd", "0").toInt()
        //1要看插屏 0不看
        return isDeleteInterAd == 1
    }


    //Begin
    fun initAdmobMaxAd() {
        if (isBlack) {
            return
        }
        if (true) {
            if (!isAdInit.get()) {
                LogEx.logDebug(TAG, "init sp Admob")
                MobileAds.initialize(BaseApplication.context) { initializationStatus ->
                    isAdInit.set(true)
                }
            }
        } else {
//            if (!isAdInit.get()) {
//                LogEx.logDebug(TAG, "init sp AdMax")
//                BaseApplication.context.initAdMax()
//            }
        }
    }

    //End end
    fun isOpenAdLoaded(): Boolean {
//         if (getSpAdmobTrueMaxFalse()) {
//
//        } else {
//            AdMaxOpenUtils.isOpenAdLoaded()
//        }
        return AdmobOpenUtils.isOpenAdLoaded()
    }

    //展示广告关闭时赋值
    var lastShowedOnHiddenTime = 0L
    fun admobMaxShowInterstitialAd(
        activity: Activity,
        isLoading: Boolean = true,
        onHidden: (() -> Unit)? = null
    ) {
        if (isBlack) {
            EventUtils.event("ad_black", "interAd")
            onHidden?.invoke()
            return
        }
        val isShowLoadingAd = AppPreferences.getInstance().getString("isShowLoadingAd", "0").toInt()
        if (isShowLoadingAd == 0 && isLoading) {
            EventUtils.event("ad_switch_close")
            onHidden?.invoke()
            return
        }
        val adInterval = AppPreferences.getInstance().getString("adInterval", "0").toInt()
        if ((System.currentTimeMillis() - lastShowedOnHiddenTime) < adInterval * 1000 && lastShowedOnHiddenTime != 0L) {
            onHidden?.invoke()
            EventUtils.event("ad_interval")
            return
        }

        if (true) {
            AdmobInterstitialUtils.showInterstitialAd(activity) {
                onHidden?.invoke()
            }
        } else {
//            AdMaxInterstitialUtils.showInterstitialAd(activity) {
//                onHidden?.invoke()
//            }
        }
    }

    fun admobMaxShowOpenAd(
        activity: Activity, showBeforeAction: (flag: Boolean) -> Unit,
        onHidden: (() -> Unit)? = null,
    ) {
        if (isBlack) {
            EventUtils.event("ad_black", "openAd")
            onHidden?.invoke()
            return
        }
        if (true) {
            AdmobOpenUtils.showAppOpenAd(activity, showBefore = showBeforeAction) {
                onHidden?.invoke()
            }
        } else {
//            AdMaxOpenUtils.showAppOpenAd(activity, loadCallBack = showBeforeAction) {
//                onHidden?.invoke()
//            }
        }
    }

    fun admobMaxShowNativeAd(activity: Activity, parent: ViewGroup, where: Int = 0) {
        if (isBlack) {
            return
        }
        val isShowResultNaAd =
            AppPreferences.getInstance().getString("isShowResultNaAd", "0").toInt()
        Log.e("MXL", "admobMaxShowNativeAd: $isShowResultNaAd")
        if (isShowResultNaAd == 0)
            return
        var layout = R.layout.layout_native_custom
        when (where) {
            0 -> layout = R.layout.layout_native_custom
            1 -> layout = R.layout.layout_nativie_custom2
        }
        AdmobNativeUtils.showNativeAd(activity, parent, layout)
//        if (true) {
//            AdmobNativeUtils.showNativeAd(activity, parent)
//        } else {
////            var layout = R.layout.layout_max_native_small
////            if (where == 0) {
////                layout = R.layout.layout_max_native_small_f8f8f8
////            }
////            if (where == 1) {
////                layout = R.layout.layout_max_native_big
////            }
////            if (where == 2) {
////                layout = R.layout.layout_max_native_big_2
////            }
////            AdMaxNativeUtils.showNativeAd(activity, parent, layout)
//        }
    }

    fun preloadAd(activity: Activity) {
        if (isBlack) {
            return
        }

        if (true) {
//            AdmobOpenUtils.loadAppOpenAd()
            AdmobInterstitialUtils.loadInterstitialAd(activity)
        } else {
            if (isAdInit.get()) {
//                AdMaxOpenUtils.loadAppOpenAd(activity)
//                AdMaxInterstitialUtils.loadInterstitialAd(activity)
            } else {
//                AdMaxInit.maxInitAction = {
                Log.d(TAG, "max init suc")
//                    AdMaxOpenUtils.loadAppOpenAd(activity)
//                    AdMaxInterstitialUtils.loadInterstitialAd(activity)
//                }
            }
        }
    }

}